﻿using System;
using System.Web.Mvc;
using System.Web.Routing;
using AngularAspNetMvc.Web.Controllers;

namespace AngularAspNetMvc.Web.App_Start
{
    public class CustomControllerFactory : DefaultControllerFactory
    {
        protected override IController GetControllerInstance(RequestContext requestContext, Type controllerType)
        {
            if (controllerType == null)
            {
                var controllerName = requestContext.RouteData.Values["controller"].ToString()
                    .Replace("Controller", "");
                var viewName = requestContext.RouteData.Values["action"].ToString();
                requestContext.RouteData.Values["controller"] = "GenericView";
                requestContext.RouteData.Values["action"] = "GetView";
                requestContext.RouteData.Values["controllerName"] = controllerName;
                requestContext.RouteData.Values["viewName"] = viewName;
                return base.GetControllerInstance(requestContext, typeof(GenericViewController));
            }
            return base.GetControllerInstance(requestContext, controllerType);
        }
    }
}