﻿using System;
using System.Data;
using System.Web.UI;
using AngularAspNetMvc.Data.Models;
using AngularAspNetMvc.DataAccess.Reports;
using AngularAspNetMvc.DataAccess.Repository;
using Microsoft.Reporting.WebForms;

namespace AngularAspNetMvc.Web.ViewsStatic
{
    public partial class ReportForm : Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                Guid requestID = new Guid(Request.QueryString["r"]);

                ReportRequest request;
                using (var repository = new ReportsRepository())
                {
                    request = repository.GetRequest(requestID);
                }
                if (request != null)
                {
                    DataSet data;
                    using (var reportsRunRepository = new ReportsRunRepository())
                    {
                        data = reportsRunRepository.GetReportData(request);
                    }
                    
                    mainReportViewer.ProcessingMode = ProcessingMode.Local;
                    mainReportViewer.LocalReport.ReportPath = Server.MapPath("~/Reports/" + request.ReportFileName);
                    mainReportViewer.ShowParameterPrompts = false;
                    mainReportViewer.ShowRefreshButton = false;
                    mainReportViewer.ShowWaitControlCancelLink = false;
                    mainReportViewer.ShowBackButton = false;
                    mainReportViewer.ShowCredentialPrompts = false;
                    mainReportViewer.LocalReport.DataSources.Add(new ReportDataSource("DataSet1", data.Tables[0]));
                    mainReportViewer.KeepSessionAlive = false;
                    mainReportViewer.AsyncRendering = false;
                }
                
            }
        }
    }
}