﻿using System;
using System.Data;
using System.Web;
using AngularAspNetMvc.Data.Models;
using AngularAspNetMvc.DataAccess.Reports;
using AngularAspNetMvc.DataAccess.Repository;
using Microsoft.Reporting.WebForms;

namespace AngularAspNetMvc.Web.ViewsStatic
{

    public class ReportForm1 : IHttpHandler
    {

        public void ProcessRequest(HttpContext context)
        {
            Guid requestID = new Guid(context.Request.QueryString["r"]);

            ReportRequest request;
            using (var repository = new ReportsRepository())
            {
                request = repository.GetRequest(requestID);
            }
            if (request != null)
            {
                DataSet data;
                using (var reportsRunRepository = new ReportsRunRepository())
                {
                    data = reportsRunRepository.GetReportData(request);
                }
                var report = new LocalReport();
                report.ReportPath = context.Server.MapPath("~/Reports/" + request.ReportFileName);
                report.DataSources.Add(new ReportDataSource("DataSet1", data.Tables[0]));
                var reportData = report.Render("PDF");
                context.Response.BinaryWrite(reportData);
                context.Response.ContentType = "application/pdf";
            }
        }

        public bool IsReusable
        {
            get
            {
                return false;
            }
        }
    }
}