
module app.contacts {

    import IUtilities = core.services.IUtilities;
    import IContactType = contactTypes.models.IContactType;
    import ContactsTypeService = contactTypes.services.ContactsTypeService;

    export class ContactsTypesController extends core.controllers.CoreController {
        contactTypes: IContactType[];
        editType = (contactType: contactTypes.models.IContactType) => {
            this.$location.path("/contacttype/edit/" + contactType.ContactTypeId);
        };
        add = () => {
            this.$location.path("/contacttype/edit/add");
        }
        getData = () => {
            this.contactsTypeService.getContactTypes((result: IContactType[]) => {
                this.contactTypes = result;
            });
        };
        deleteType = (contactType: IContactType) => {
            var buttons: core.services.IButtonForMessage[] = [
                {
                    mehtod: () => {
                        this.handleDeleteType(contactType);
                    },
                    label: "Delete"
                },
                {
                    label: "Cancel"
                }
            ];
            this.utilities.showMessage("Delete type " + contactType.Name + "?", false, buttons);
        }
        handleDeleteType = (contactType: contactTypes.models.IContactType) => {
            this.contactsTypeService.deleteContactType(contactType, (result: boolean) => {
                if (result) {
                    this.getData();
                }
            });
        }

        constructor(
            private utilities: IUtilities,
            private $location: ng.ILocationService,
            private contactsTypeService: ContactsTypeService) {
            super();

            this.getData();

        }

    }

    angular.module("app.contacts.contactsTypesController",
        ["app.core.services.utilities", "app.core.services.http", "app.contactTypes.services"])
        .controller("app.contacts.contactsTypesController", ["utilities", "$location", "contactsTypeService", ContactsTypesController]);
}