
module app.contacts {

    import IUtilities = core.services.IUtilities;
    import IContactType = contactTypes.models.IContactType;

    interface IContactTypeRouteParams extends ng.route.IRouteParamsService {
        id: any;
    }

    class ContactsTypesEditController extends core.controllers.CoreController {
        model: IContactType;
        save = () => {
            this.contactsTypeService.saveContactType(this.model, (result: IContactType) => {
                this.model = result;
                this.$location.path("/contacttypes");
            });
        }
        cancel = () => {
            this.$location.path("/contacttypes");
        }
        constructor(
            private contactsTypeService: contactTypes.services.ContactsTypeService,
            private utilities: IUtilities,
            private $routeParams: IContactTypeRouteParams,
            private $location: ng.ILocationService) {
            super();
            var self = this;

            var id = $routeParams.id;
            if (id === "add") {
                self.model = {
                    ContactTypeId: 0,
                    Name: ""
                };
            } else {
                contactsTypeService.getContactType(id, (result: IContactType)=> {
                    self.model = result;
                });
            }

        }
    }

    angular.module("app.contacts.contactsTypesEditController", ["app.core.services.utilities", "app.contactTypes.services"])
        .controller("app.contacts.contactsTypesEditController",
            ["contactsTypeService", "utilities", "$routeParams", "$location", ContactsTypesEditController]);
}