var app;
(function (app) {
    var contactTypes;
    (function (contactTypes) {
        var services;
        (function (services) {
            var ContactsTypeService = (function () {
                function ContactsTypeService(http) {
                    this.http = http;
                }
                ContactsTypeService.prototype.getContactTypes = function (callback) {
                    return this.http.get("/ContactTypes/Get", function (result) {
                        if (result.Success) {
                            callback(result.Result);
                        }
                    }, true);
                };
                ContactsTypeService.prototype.getContactType = function (id, callback) {
                    return this.http.get("/ContactTypes/GetById", function (result) {
                        if (result.Success) {
                            callback(result.Result);
                        }
                    }, true, { contactTypeId: id });
                };
                ContactsTypeService.prototype.deleteContactType = function (contactType, callback) {
                    return this.http.post("/ContactTypes/Delete", contactType, function (result) {
                        callback(result.Success);
                    }, true);
                };
                ContactsTypeService.prototype.saveContactType = function (contactType, callback) {
                    return this.http.post("/ContactTypes/Save", contactType, function (result) {
                        if (result.Result) {
                            callback(result.Result);
                        }
                    }, true);
                };
                return ContactsTypeService;
            })();
            services.ContactsTypeService = ContactsTypeService;
            angular.module("app.contactTypes.services", [])
                .service("contactsTypeService", ["http", ContactsTypeService]);
        })(services = contactTypes.services || (contactTypes.services = {}));
    })(contactTypes = app.contactTypes || (app.contactTypes = {}));
})(app || (app = {}));
//# sourceMappingURL=contactsTypeService.js.map