

module app.contactTypes.services {

    import IHttpResult = core.services.http.IHttpResult;
    import IContactType = contactTypes.models.IContactType;


    export class ContactsTypeService {
        getContactTypes(callback: (result: IContactType[]) => void) {
            return this.http.get("/ContactTypes/Get", (result: IHttpResult<IContactType[]>) => {
                if (result.Success) {
                    callback(result.Result);
                }
            }, true);
        }
        getContactType(id: number, callback: (result: IContactType) => void) {
            return this.http.get("/ContactTypes/GetById", (result: IHttpResult<IContactType>) => {
                if (result.Success) {
                    callback(result.Result);
                }
            }, true, { contactTypeId: id });
        }
        deleteContactType(contactType: IContactType, callback: (result: boolean) => void) {
            return this.http.post("/ContactTypes/Delete", contactType, (result: IHttpResult<IContactType>) => {
                callback(result.Success);
            }, true);
        }
        saveContactType(contactType: IContactType, callback: (result: IContactType) => void) {
            return this.http.post("/ContactTypes/Save", contactType, (result: IHttpResult<IContactType>) => {
                if (result.Result) {
                    callback(result.Result);
                }
            }, true);
        }

        constructor(private http: core.services.http.IHttp) {
        }
    }

    angular.module("app.contactTypes.services", [])
        .service("contactsTypeService", ["http", ContactsTypeService]);
}