var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
var app;
(function (app) {
    var contacts;
    (function (contacts) {
        var ContactsController = (function (_super) {
            __extends(ContactsController, _super);
            function ContactsController(utilities, $location, contactsService) {
                var _this = this;
                _super.call(this);
                this.utilities = utilities;
                this.$location = $location;
                this.contactsService = contactsService;
                this.lastUsedName = null;
                this.editContact = function (contact) {
                    _this.$location.path("/contact/edit/" + contact.ContactId);
                };
                this.add = function () {
                    _this.$location.path("/contact/edit/add");
                };
                this.handleDeleteContact = function (contact) {
                    _this.contactsService.deleteContact(contact, _this.deleted);
                };
                this.deleted = function (result) {
                    if (result) {
                        _this.search(_this.currentPage, _this.pageSize, _this.name, "searchCompleted");
                    }
                };
                this.deleteContact = function (contact) {
                    var buttons = [
                        {
                            mehtod: function () {
                                _this.handleDeleteContact(contact);
                            },
                            label: "Delete"
                        },
                        {
                            label: "Cancel"
                        }
                    ];
                    _this.utilities.showMessage("Delete " + contact.LastName + ", " + contact.FirstName + "?", false, buttons);
                };
                var self = this;
                self.search = function (pageNumber, pageSize, name, eventToRaise) {
                    if (!(self.lastUsedName === name)) {
                        pageNumber = 1;
                        self.lastUsedName = name;
                    }
                    contactsService.getContacts({ PageNumber: pageNumber, PageSize: pageSize, Name: name }, function (result) {
                        self.contacts = result.Result;
                        self.pageCount = result.TotalPages;
                        self.totalFound = result.TotalRows;
                        self.currentPage = pageNumber;
                        self.state = eventToRaise;
                    });
                };
                self.search(1, self.pageSize, self.name, "searchCompleted");
            }
            return ContactsController;
        })(app.core.controllers.PagedController);
        angular.module("app.contacts.contactsController", ["app.core.services.utilities", "app.contacts.services"])
            .controller("app.contacts.contactsController", ["utilities", "$location", "contactsService", ContactsController]);
    })(contacts = app.contacts || (app.contacts = {}));
})(app || (app = {}));
//# sourceMappingURL=contactsController.js.map