
module app.contacts {

    import IUtilities = core.services.IUtilities;
    import ContactsService = contacts.services.ContactsService;
    import IContactInfo = contacts.models.IContactInfo;
    import IPagedResult = core.services.http.IPagedResult;


    class ContactsController extends core.controllers.PagedController {
        contacts: IContactInfo[];
        lastUsedName: string = null;
        editContact = (contact: IContactInfo) => {
            this.$location.path("/contact/edit/" + contact.ContactId);
        };
        add = () => {
            this.$location.path("/contact/edit/add");
        };
        handleDeleteContact = (contact: IContactInfo) => {
            this.contactsService.deleteContact(contact, this.deleted);
        };
        deleted = (result: boolean) => {
            if (result) {
                this.search(this.currentPage, this.pageSize, this.name, "searchCompleted");
            }
        };
        deleteContact = (contact: contacts.models.IContactInfo) => {
            var buttons: core.services.IButtonForMessage[] = [
                {
                    mehtod: () => {
                        this.handleDeleteContact(contact);
                    },
                    label: "Delete"
                },
                {
                    label: "Cancel"
                }
            ];
            this.utilities.showMessage("Delete " + contact.LastName + ", " + contact.FirstName + "?", false, buttons);
        }
        constructor(
            private utilities: IUtilities,
            private $location: ng.ILocationService,
            private contactsService: ContactsService) {
            super();
            var self = this;
            self.search = (pageNumber: number, pageSize: number, name: string, eventToRaise: string) => {
                if (!(self.lastUsedName === name)) {
                    pageNumber = 1;
                    self.lastUsedName = name;
                }
                contactsService.getContacts(
                    { PageNumber: pageNumber, PageSize: pageSize, Name: name },
                    (result: IPagedResult<IContactInfo>) => {
                        self.contacts = result.Result;
                        self.pageCount = result.TotalPages;
                        self.totalFound = result.TotalRows;
                        self.currentPage = pageNumber;
                        self.state = eventToRaise;
                    });
            };

            self.search(1, self.pageSize, self.name, "searchCompleted");

        }

    }

    angular.module("app.contacts.contactsController", ["app.core.services.utilities", "app.contacts.services"])
        .controller("app.contacts.contactsController", ["utilities", "$location", "contactsService", ContactsController]);
}