module app.contacts {

    import IUtilities = core.services.IUtilities;
    import ContactsService = contacts.services.ContactsService;
    import IContact = contacts.models.IContact;
    import ContactsTypeService = contactTypes.services.ContactsTypeService;
    import IContactType = contactTypes.models.IContactType;

    interface IContactTypesEditScope extends core.controllers.ICoreScope {
        save: () => void;
        cancel: () => void;
        model: IContact;
        contactTypes: IContactType[];
    }

    interface IContactRouteParams extends ng.route.IRouteParamsService {
        id: any;
    }

    class ContactsEditController extends core.controllers.CoreController {
        model: IContact;
        contactTypes: IContactType[];
        save = () => {
            // ReSharper disable UnusedParameter
            this.contactsService.saveContact(this.model, (result: IContact) => {
                this.$location.path("/contacts");
            });
            // ReSharper restore UnusedParameter
        }
        cancel = () => {
            this.$location.path("/contacts");
        };
        constructor(
            private utilities: IUtilities,
            $routeParams: IContactRouteParams,
            private $location: ng.ILocationService,
            private contactsService: ContactsService,
            contactsTypeService: ContactsTypeService) {
            super();
            var self = this;
            var id = $routeParams.id;
            if (id === "add") {
                contactsTypeService.getContactTypes((typesResult: IContactType[]) => {
                    self.contactTypes = typesResult;
                    if (typesResult) {
                        self.model = {
                            ContactId: 0,
                            ContactTypeId: 0,
                            FirstName: "",
                            LastName: "",
                            IsActive: true
                        };
                    }
                });
            } else {
                contactsTypeService.getContactTypes((typesResult: IContactType[]) => {
                    self.contactTypes = typesResult;
                    if (typesResult) {
                        contactsService.getContact(id, (result: IContact) => {
                            self.model = result;
                        });
                    }
                });
            }

        }
    }

    angular.module("app.contacts.contactsEditController",
        ["app.core.services.utilities", "app.contacts.services", "ngRoute", "app.contactTypes.services"])
        .controller("app.contacts.contactsEditController",
            ["utilities", "$routeParams", "$location", "contactsService", "contactsTypeService", ContactsEditController]);
}