var app;
(function (app) {
    var contacts;
    (function (contacts) {
        var services;
        (function (services) {
            var ContactsService = (function () {
                function ContactsService(http) {
                    this.http = http;
                }
                ContactsService.prototype.getContacts = function (criteria, callback) {
                    return this.http.get("/Contacts/Get", function (pagedResult) {
                        if (pagedResult.Success) {
                            callback(pagedResult.Result);
                        }
                    }, true, criteria);
                };
                ContactsService.prototype.getContact = function (id, callback) {
                    return this.http.get("/Contacts/GetById", function (result) {
                        if (result.Success) {
                            callback(result.Result);
                        }
                    }, true, { contactId: id });
                };
                ContactsService.prototype.deleteContact = function (contact, callback) {
                    return this.http.post("/Contacts/Delete", contact, function (result) {
                        callback(result.Success);
                    }, true);
                };
                ContactsService.prototype.saveContact = function (contact, callback) {
                    return this.http.post("/Contacts/Save", contact, function (result) {
                        if (result.Result) {
                            callback(result.Result);
                        }
                    }, true);
                };
                return ContactsService;
            })();
            services.ContactsService = ContactsService;
            angular.module("app.contacts.services", [])
                .service("contactsService", ["http", ContactsService]);
        })(services = contacts.services || (contacts.services = {}));
    })(contacts = app.contacts || (app.contacts = {}));
})(app || (app = {}));
//# sourceMappingURL=contactsService.js.map